'use strict';

const browshot = require('browshot');

var client = new browshot('my_api_key');

var interval;

client.screenshotCreate({url: 'http://mobilio.net/', instance_id: 12 }, function(screenshot) {
		// If the screenshot is already in cache, it could be finished already. Otherwise, wait longer
		if (screenshot.status == 'error') {
			console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
		}
		else if (screenshot.status == 'finished') {
			screenshotFinished(screenshot);
		}
		else {
			interval = setInterval(checkScreenshot, 1000 * 10, screenshot.id);
		}
	}
);

function checkScreenshot(id) {
	client.screenshotInfo(id, { }, function(screenshot) {
		if (screenshot.status == 'error') {
			clearInterval(interval);
			
			console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
		}
		else if (screenshot.status == 'finished') {
			clearInterval(interval);
			
			screenshotFinished(screenshot);
		}
		else {
			console.log(`Waiting for screenshot #${screenshot.id} to finish...`);
		}
	});
}

function screenshotFinished(screenshot) {
	// share a screenshot (must be in finished state)
	client.screenshotShare(screenshot.id, { note: 'Browshot is great!' }, function(share) {
		if (share.status == 'ok')
			console.log(`Screenshot shared at ${share.url}`);
		else
			console.log(`Sharing failed: ${share.error}`);
	});
}